﻿using Connected.Middleware;
using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Logging;

namespace Connected.Components;

public abstract class UIComposition : ComponentBase
{
	private ILogger _logger;

	[Inject]
	private ILoggerFactory LoggerFactory { get; set; } = default!;

	[Inject]
	private IComponentMiddlewareService? MiddlewareService { get; set; }

	protected ILogger Logger => _logger ??= LoggerFactory.CreateLogger(GetType());

	protected Type ResolveComponent<TComponent>()
	{
		if (MiddlewareService is null)
			return typeof(TComponent);

		if (MiddlewareService.Select<TComponent>() is Type type)
			return type;

		return typeof(TComponent);
	}
}
